#version 100
#extension GL_OES_EGL_image_external : require //申明使用扩展纹理
precision highp float;
varying vec2 v_texcoord;
uniform samplerExternalOES s_texture;
uniform vec2 u_texSize;
uniform highp float time;//时间,单位 s

#define iterations 16
#define formuparam 0.53

#define starlayers 4
#define stepsize 0.1

#define zoom   0.800
#define tile   0.850
#define speed  0.001

#define brightness 0.0015
#define darkmatter 0.300
#define distfading 0.730
#define saturation 0.850

void main() {
    vec2 uv = v_texcoord;
    uv = 1.0 - uv;
    uv.x = 1.0 - uv.x;
    uv.y = 1.0 - uv.y;
    uv -= 0.5;
    uv.y*=u_texSize.y/u_texSize.x;
    vec3 dir=vec3(uv*zoom, 1.0);
    float innerTime=time*speed+0.25;

    //orientation
    float a1=0.5;
    float a2=0.8;
    mat2 rot1=mat2(cos(a1), sin(a1), -sin(a1), cos(a1));
    mat2 rot2=mat2(cos(a2), sin(a2), -sin(a2), cos(a2));
    dir.xz*=rot1;
    dir.xy*=rot2;
    vec3 from=vec3(1.0, 0.5, 0.5);
    from+=vec3(innerTime*2.0, innerTime, -2.0);
    from.xz*=rot1;
    from.xy*=rot2;

    //rendering
    float s=0.1, fade=1.0;
    vec3 v=vec3(0.0);
    for (int r=0; r<starlayers; r++) {
        vec3 p=from+s*dir*0.5;
        p = abs(vec3(tile)-mod(p, vec3(tile*2.0)));
        float pa, a=pa=0.0;
        for (int i=0; i<iterations; i++) {
            p=abs(p)/dot(p, p)-formuparam;
            a+=abs(length(p)-pa);
            pa=length(p);
        }
        float dm=max(0.0, darkmatter-a*a*0.001);
        a*=a*a;
        //a *= smoothstep(0.2, 1.2, a);
        if (r>6) fade*=1.0-dm;
        //v+=fade*fade;
        v+=fade;
        v+=vec3(s, s*s, s*s*s*s)*a*brightness*fade;
        fade*=distfading;
        s+=stepsize;
    }

    v=mix(vec3(length(v)), v, saturation);

    gl_FragColor = vec4(v*0.01, 1.0);
}